﻿unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, DB, ADODB, ComCtrls, Grids, DBGrids, StdCtrls, ImgList, RVScroll,
  RichView, RVStyle, ExtCtrls, DBCtrls, RVTable, Jpeg, RVItem, CRVFData;

type
  TForm1 = class(TForm)
    ADOConnection1: TADOConnection;
    ADOTable1: TADOTable;
    ADOTable2: TADOTable;
    ADOTable1id_cat: TWideStringField;
    ADOTable1Catego: TWideStringField;
    DataSource1: TDataSource;
    DataSource2: TDataSource;
    DBGrid1: TDBGrid;
    DBGrid2: TDBGrid;
    RVStyle1: TRVStyle;
    RichView1: TRichView;
    Label2: TLabel;
    ImageList1: TImageList;
    ADOTable2id_Cat: TWideStringField;
    ADOTable2id_pers: TWideStringField;
    ADOTable2Name_pers: TWideStringField;
    ADOTable2Phone_pers: TIntegerField;
    ADOTable2Email_pers: TWideStringField;
    Image1: TImage;
    procedure FormCreate(Sender: TObject);
    procedure RichView1Jump(Sender: TObject; id: Integer);
  private
    { Déclarations privées }
    UserId: Integer;
    ExpandedCategories: array of Boolean;
    procedure BuildUserList;
  public
    { Déclarations publiques }
  end;

var
  Form1: TForm1;

const PARA_NORMAL = 0;
      PARA_CATEGORY = 1;

      TEXT_NORMAL = 0;
      TEXT_CATEGORY = 1;
      TEXT_SELECTEDUSER = 2;
      TEXT_USER = 3;

implementation

{$R *.dfm}


procedure TForm1.BuildUserList;
var i,j: Integer;
    Table: TRVTableItemInfo;
    jpg: TJPEGImage;
begin
  RichView1.Clear;
  ADOTable1.First;
  for i:=0 to ADOTable1.RecordCount-1 do begin
    // adding a category
    RichView1.AddHotspotExTag( '', ord(ExpandedCategories[i]), ord(ExpandedCategories[i]),
      ImageList1, PARA_CATEGORY, 'cat:'+IntToStr(i));
    RichView1.AddTag(ADOTable1.FieldValues['Catego'], TEXT_CATEGORY,
      'cat:'+IntToStr(i));
    if ExpandedCategories[i] then begin
      ADOTable2.First;
      for j:=0 to ADOTable2.RecordCount-1 do begin
        if ADOTable2.FieldValues['id_cat'] =ADOTable1.FieldValues['Id_Cat']then begin
          if UserId<0 then // if UserId is not defined, making the first user selected
             UserId := ADOTable2.FieldValues['id_pers'];
          if UserId<>ADOTable2.FieldValues['id_pers'] then
            // adding a normal user
            RichView1.AddNLTag(ADOTable2.FieldValues['Name_pers'], TEXT_USER, PARA_NORMAL,
              'user:'+String(ADOTable2.FieldValues['id_pers']))
          else begin
            // adding a selected user
            UserId := ADOTable2.FieldValues['id_pers'];
            table := TRVTableItemInfo.CreateEx(2,2, RichView1.RVData);
            table.BorderWidth := 1;
            table.Color := clWindow;
            table.BorderStyle := rvtbColor;
            table.BorderColor := clBtnShadow;
            table.MergeCells(0, 0, 2, 1, False);
            table.BestWidth := -100;
            with table.Cells[0,0] do begin
              Clear;
              AddNL(ADOTable2.FieldValues['Name_pers'], TEXT_SELECTEDUSER, -1);
              Color := clInactiveCaption;
            end;
            with table.Cells[1,0] do begin
              Clear;
              jpg := TJPEGImage.Create;
              jpg.Assign(Image1.Picture.Graphic);
              AddPictureEx('', jpg, 0, rvvaBaseline);
              BestWidth := jpg.Width;
            end;
            with table.Cells[1,1] do begin
              Clear;
              AddHotspotExTag('', 4, 5, ImageList1, PARA_NORMAL, 'call:'+String(ADOTable2.FieldValues['Phone_pers']));
              SetItemExtraStrProperty(ItemCount-1, rvespHint, 'Call '+String(ADOTable2.FieldValues['Phone_pers']));
              AddHotspotExTag('', 2, 3, ImageList1, -1, 'mailto:'+ADOTable2.FieldValues['Email_pers']);
              SetItemExtraStrProperty(ItemCount-1, rvespHint, 'Email to '+String(ADOTable2.FieldValues['Email_pers']));
              Color := clWindow;
            end;
            RichView1.AddItem('', table);
          end;
        end;
        ADOTable2.Next;
      end;
    end;
    ADOTable1.Next;
  end;
  RichView1.Format;
  Label2.Caption := 'Selected user id: '+IntToStr(UserId);
end;
{------------------------------------------------------------------------------}
procedure TForm1.FormCreate(Sender: TObject);
var i: Integer;
begin
  // ExpandedCategories[i]=True if the i-th category is displayed expanded
  // This demo does not update ExpandedCategories when ADOTable1 is edited -
  // you need to implement it youself
  SetLength(ExpandedCategories, ADOTable1.RecordCount);
  for i := 1 to High(ExpandedCategories) do
    ExpandedCategories[i] := False;
  if High(ExpandedCategories)>=0 then
    ExpandedCategories[0] := True;
  UserId := -1;
  BuildUserList;
end;
{------------------------------------------------------------------------------}
// Clicking a hyperlink
procedure TForm1.RichView1Jump(Sender: TObject; id: Integer);
var RVData: TCustomRVFormattedData;
    ItemNo, p: Integer;
    Tag, Cmd, Val: String;
begin
  RichView1.GetJumpPointLocation(id, RVData, ItemNo);
  Tag := RVData.GetItemTag(ItemNo);
  p := Pos(':', Tag);
  if p=0 then
    exit;
  Cmd := Copy(Tag, 1, p-1);
  Val := Copy(Tag, p+1, Length(Tag));
  if Cmd='cat' then begin
    // expanding/collapsing the category
    ExpandedCategories[StrToInt(Val)] := not ExpandedCategories[StrToInt(Val)];
    BuildUserList
    end
  else if Cmd='user' then begin
    // selecting the user
    UserId := StrToInt(Val);
    BuildUserList;
    end
  else if (Cmd='mailto') then begin
    // user's email
    Application.MessageBox(PChar('E-mail: '+Val), 'Information', MB_OK or MB_ICONINFORMATION);
    end
  else if (Cmd='call') then begin
    // user's phone
    Application.MessageBox(PChar('Phone: '+Val), 'Information', MB_OK or MB_ICONINFORMATION);
  end;
end;

end.


